unit Unit1;
//aa@bitsmart.com

interface

uses Forms, Windows, db, DBTables, Grids, DBGrids, StdCtrls, dbCheckFlags, Spin, DBCtrls,
  ExtCtrls, Controls, Classes, SysUtils;
//  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
//  Db, DBTables, StdCtrls, Grids, DBGrids, ExtCtrls, DBCtrls,
//  Spin, dbCheckFlags, Mask;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    Panel1: TPanel;
    OpenData: TButton;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    SpinEdit1: TSpinEdit;
    dbCheckFlags100: TdbCheckFlags;
    Bevel1: TBevel;
    Splitter1: TSplitter;
    ComboBox22: TComboBox;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    procedure OpenDataClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpinEdit1Change(Sender: TObject);
    procedure BuilddbCheckFlagsList(Sender: TObject);
    procedure Table1AfterScroll(DataSet: TDataSet);
    procedure FormCreate(Sender: TObject);
    procedure ComboBox22DropDown(Sender: TObject);
    procedure ComboBox22Change(Sender: TObject);
    procedure ComboBox1DropDown(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.OpenDataClick(Sender: TObject);
begin
  with table1 do if active then close else open;
  with table1 do if not active then begin
    ComboBox22.items.Clear;
    ComboBox22Change(ComboBox22);
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  table1.close
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  if dbCheckFlags100.CheckBitNo<>TSpinEdit(Sender).Value then
    dbCheckFlags100.CheckBitNo:=TSpinEdit(Sender).Value;
end;

procedure TForm1.Table1AfterScroll(DataSet: TDataSet);
begin
  if SpinEdit1.Value<>dbCheckFlags100.CheckBitNo then
    SpinEdit1.Value:=dbCheckFlags100.CheckBitNo
end;

procedure TForm1.BuilddbCheckFlagsList(Sender: TObject);
var
  Corner: TPoint;
  i, j, Counter: Integer;
const
  ROWS = 4; ROWSPACE = 20; TOPSLACK = 4;
  COLS = 8; COLSPACE = 40; LEFTSLACK = 12;
begin
  Counter:= 0;
  Corner.y:= Bevel1.Top + TOPSLACK;
  Corner.x:= Bevel1.Left + LEFTSLACK;
  for i:=0 to ROWS-1 do begin
    for j:=COLS-1 downto 0 do begin
      with tdbCheckFlags.Create(Self) do begin
        Parent:=Panel1;
        Top:= Corner.y + (ROWSPACE * i);
        Left:= Corner.x + (COLSPACE * j);
        Width:=COLSPACE;
        DataSource:=DataSource1;
        //DataField:='FLAGS';
        Caption:=format('%0.2d', [Counter]);
        CheckBitNo:= Counter; inc(Counter);
      end;
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Caption:='CheckFlags - Demo Program';
  SpinEdit1.Value:=dbCheckFlags100.CheckBitNo;
  BuilddbCheckFlagsList(Self);
end;

procedure TForm1.ComboBox1DropDown(Sender: TObject);
var cb:TComboBox;
begin
  cb:=TComboBox(Sender);
  Session.GetDatabaseNames(cb.Items);
end;

procedure TForm1.ComboBox22DropDown(Sender: TObject);
var cb:TComboBox;
begin
  cb:=TComboBox(Sender);
  if table1.active then begin
    if cb.Items.count<1 then
      table1.GetFieldNames(cb.Items)
  end
  else
    cb.Items.Clear;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  with TComboBox(Sender) do
    Session.GetTableNames(Text, '', TRUE, FALSE, ComboBox2.Items);
  with Table1 do if not active then
    DatabaseName:= TComboBox(Sender).Text
  else
    //raise exception.Create('close opening table first')
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
  with Table1 do if not active then
    TableName:= TComboBox(Sender).Text
  else
    //raise exception.Create('close opening table first')
end;

procedure TForm1.ComboBox22Change(Sender: TObject);
var i:Integer;
begin
  with Panel1 do
    for i:= 0 to ControlCount-1 do
      if Controls[i] is TdbCheckFlags then
        TdbCheckFlags(Controls[i]).DataField:= TComboBox(Sender).Text;
end;

end.

